'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5169] on 6 February 2003 at 1:36:12 pm'!
"Change Set:		7-ClosureCompilerFixes-ajh
Date:			6 February 2003
Author:			Anthony Hannan

Fixes up some code including a couple of bugs found by Avi Bryant (thanks)."!


!InstructionBuilder commentStamp: 'ajh 2/6/2003 13:14' prior: 0!
I provide a simple abstract bytecode interface for creating BytecodeInstructions.  These instructions can then be translated into a CompiledMethod.  For example, to create instructions that switches x values of two points (the receiver and the arg) and returns 'equal' if equal, do:

	InstructionBuilder new
		rargs: #(self otherPoint);		"receiver and args declarations"
		addTemps: #(z);					"temp declariations"
		pushTemp: #self;
		getField: 1;
		storeTemp: #z;						"z _ x."
		pushTemp: #otherPoint;
		send: #x;
		pushTemp: #self;
		setField: 1;						"x _ otherPoint x"
		doPop;
		pushTemp: #otherPoint;
		pushTemp: #z;
		send: #setX:;						"otherPoint setX: z"
		doPop;
		pushTemp: #z;
		pushTemp: #self;
		getField: 1;
		send: #=;						"z = x"
		jumpAheadTo: #notEqual if: false;
		pushLiteral: 'equal';				"ifTrue: ['equal']"
		jumpAheadTo: #end;
		jumpAheadTarget: #notEqual;
		pushLiteral: 'not equal';			"ifFalse: ['not equal']"
		jumpAheadTarget: #end;
		localReturnTop;
		yourself

To see a printout of the instructions, send #longPrintString to the resulting instructionBuilder.  To convert the instructions to a CompiledMethod, send #compiledMethodWith: #(0) to it.
!


!Object methodsFor: 'binding' stamp: 'ajh 2/6/2003 13:24'!
hasLiteralSuchThat: testBlock
	"This is the end of the imbedded structure path so return false."

	^ false! !


!Array methodsFor: 'private' stamp: 'ajh 2/6/2003 13:22'!
hasLiteralSuchThat: testBlock

	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit _ self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !


!BlockClosure methodsFor: 'accessing' stamp: 'ajh 2/6/2003 13:24'!
hasLiteralSuchThat: testBlock

	(testBlock value: method) ifTrue: [^ true].
	^ method hasLiteralSuchThat: testBlock! !

!BlockClosure methodsFor: 'scheduling' stamp: 'ajh 2/6/2003 13:33'!
newProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."

	<primitive: 19> "Simulation guard"
	^ Process
		forContext: 
			[self value.
			Processor terminateActive]
		priority: Processor activePriority! !

!BlockClosure methodsFor: 'inspecting' stamp: 'ajh 2/6/2003 13:27'!
hasMethodReturn
	"Answer whether the receiver has a return ('^') in its code."

	^ self method remoteReturns! !

!BlockClosure methodsFor: 'inspecting' stamp: 'ajh 2/6/2003 12:48'!
searchImageForHomeMethod

	Smalltalk allObjectsDo: [:obj |
		obj class == CompiledMethod ifTrue: [
			(obj pointsTo: self) ifTrue: [^ obj searchImageForHomeMethod]
		] ifFalse: [obj class == BlockClosure ifTrue: [
			(obj method == self and: [obj size = 0])
				ifTrue: [^ obj searchImageForHomeMethod]
		]]
	].
	^ method  "must be a loner block method"! !


!CompiledMethod methodsFor: 'literals' stamp: 'ajh 2/6/2003 13:25'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this method, even if imbedded."

	| lit |
	2 to: self numLiterals + 1 do: 
		[:index | 
		(testBlock value: (lit _ self objectAt: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 2/6/2003 13:27'!
remoteReturns
	"For closure methods only"

	^ self messages includes: #remoteReturnTo:! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 2/6/2003 12:48'!
searchImageForHomeMethod

	Smalltalk allObjectsDo: [:obj |
		obj class == CompiledMethod ifTrue: [
			(obj pointsTo: self) ifTrue: [^ obj searchImageForHomeMethod]
		] ifFalse: [obj class == BlockClosure ifTrue: [
			(obj method == self and: [obj size = 0])
				ifTrue: [^ obj searchImageForHomeMethod]
		]]
	].
	^ self  "must be a loner block method"! !


!JumpIfInstr methodsFor: 'as yet unclassified' stamp: 'ajh 2/5/2003 12:08'!
jumpBytecodes: sequenceOrder

	| from to distance continue stream bytes |
	from _ sequenceOrder identityIndexOf: owningSequence.
	to _ sequenceOrder identityIndexOf: destinationSequence.
	from < to ifFalse: [self errorConditionalJumpBackwards].
	continue _ sequenceOrder identityIndexOf: otherwiseSequence.
	from + 1 = continue ifFalse: [self errorFallThroughSequenceNotNext].
	stream _ Compiler bytecodeWriteStream on: (ByteArray new: 4).
	to = continue ifTrue: [
		"jumps to fall-through branch, condition irrelevant.  Eg. x ifTrue: []."
		stream popTop.
	] ifFalse: [
		distance _ (from + 1 to: to - 1) inject: 0 into: [:size :i | 
			size + (sequenceOrder at: i) bytecodesSize].
		stream jump: distance if: jumpCondition.
	].
	bytes _ stream contents.
	localBytecodeRange _ owningSequence bytecodesWithoutJump size + 1 extend: bytes size.
	^ bytes! !

InstructionBuilder removeSelector: #compiledMethod!
BlockClosure removeSelector: #decompile!
